Package com.emc.d2fs.interfaces

# Interface IMethodService

All Superinterfaces:
  `ID2fsService`

public interface IMethodService extends ID2fsService
D2 Method services. Provides access to ID2Method implementation.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MethodResult`
  `executeMethod(Context context, String id, List<Attribute> arguments)`
  Execute method specified by class name.
  `List<Attribute>`
  `executeMethodWithListResult(Context context, String id, List<Attribute> arguments)`
  Execute method executeMethod but instead of having a complex return type, you get a List which may be convenient for some customization.

  ### Methods inherited from interface com.emc.d2fs.interfaces.ID2fsService

  `isRemote, setRemote`

- ## Method Details

  - ### executeMethod

    MethodResult executeMethod(Context context, String id, List<Attribute> arguments) throws D2fsException
    Execute method specified by class name. The class must implement ID2Method. class name must be passed along with the arguments list, key: -class_name

    For the full list of possible argument keys, please check the `com.emc.d2.api.methods.D2Method`

    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of id if -id is already in the list of arguments, this id won't be effective
      `arguments` - `Attribute` list of arguments needed by the method
    Returns:
      `MethodResult` object as process result
    Throws:
      `D2fsException`
    Since:
      4.0.1

  - ### executeMethodWithListResult

    List<Attribute> executeMethodWithListResult(Context context, String id, List<Attribute> arguments) throws D2fsException
    Execute method executeMethod but instead of having a complex return type, you get a List which may be convenient for some customization. For more information
    Parameters:
      `context` - `Context` object containing informations about client/session
      `id` - String value of id if -id is already in the list of arguments, this id won't be effective
      `arguments` - `Attribute` list of parameters
    Returns:
      `Attribute` list of object as process result
    Throws:
      `D2fsException`
    Since:
      4.1.0